# Abbildung 30 (Mafobuch, Regressionsanalyse lm)
library(ggrepel); setwd("C:/Users/Alpha/Desktop/R")
Data=read.csv("Beispiel1.csv",header=TRUE,sep=";",dec=",")
  
fit=lm(Einkommen~Alter,data=Data); summary(fit)
plot(Einkommen~Alter,data=Data); abline(fit)
b0=fit$coefficients[1]; b1=fit$coefficients[2]
yquer=mean(Data$Einkommen); i=31; xi=Data$Alter[i]; yi=Data$Einkommen[i]
ycut=b0+b1*xi
ytext1=(yquer+yi)/2
ytext2=(yquer+ycut)/2-3
ytext3=(ycut+yi)/2; Data$size=1
  
pdf(file="pdf/Abb79.pdf",width=11.7/2.54, height=11.7/2.54)
ggplot(Data,aes(Alter,Einkommen,label=Kunde)) +
  geom_point(size=Data$size) +
  geom_text_repel(parse=TRUE,box.padding=0.1,size=3,
                  point.padding=0.1,position="identity") +
  theme_classic(base_size=9) +
  xlab("Alter (in Jahren)") + ylab("Einkommen (in 1.000  pro Jahr)") +
  theme(axis.title.x = element_text(size=9)) +
  theme(axis.text.x = element_text(size = 9)) +
  theme(axis.title.y = element_text(size=9)) + 
  theme(axis.text.y = element_text(size = 9)) +
  theme(axis.line.y=element_line(color='black',size=0.25))+
  theme(axis.line.x=element_line(color='black',size=0.25))+
  theme(axis.ticks=element_line(color='black',size=0.25))+ 
  expand_limits(x=0, y=0) + expand_limits(x=70, y=110) + 
  scale_x_continuous(expand = c(0, 0)) + 
  scale_y_continuous(expand = c(0, 0)) +
  geom_abline(intercept=b0,slope=b1,linetype="solid",size=0.25) +
  geom_hline(yintercept=yquer,linetype="longdash",size=0.25)+
  annotate("text",x=66,y=yquer*0.94,parse=TRUE,
           label="bar(y)") +
  geom_segment(aes(x=xi,y=0,xend=xi,yend=yi),linetype="longdash",size=0.25) +
  geom_segment(aes(x=xi-0.5,y=ycut,xend=xi-0.5,yend=yi),
               linetype="solid",size=0.25,
               arrow = arrow(angle=10,ends="both",
              length = unit(0.05,"inches"),type="closed"))+
  geom_segment(aes(x=xi-0.5,y=yquer,xend=xi-0.5,yend=ycut),
               linetype="solid",size=0.25,
               arrow = arrow(angle=10,ends="both",
              length = unit(0.05,"inches"),type="closed"))+
  geom_segment(aes(x=xi+0.5,y=yquer,xend=xi+0.5,yend=yi),
               linetype="solid",size=0.25,
               arrow = arrow(angle=10,ends="both",
              length = unit(0.05,"inches"),type="closed"))+
  geom_segment(aes(x=xi-1.5,y=yquer,xend=xi+1.5,yend=yquer),linetype="solid",size=0.25)+
  geom_segment(aes(x=xi-1.5,y=ycut,xend=xi,yend=ycut),linetype="solid",size=0.25)+
  geom_segment(aes(x=xi-1.5,y=yi,xend=xi+1.5,yend=yi),linetype="solid",size=0.25)+
  annotate("text",x=xi+3.25,y=ytext1,parse=TRUE,
           label="y[i]-bar(y)",size=3) +
  annotate("text",x=xi-3.25,y=ytext2,parse=TRUE,
           label="hat(y)[i]-bar(y)",size=3) +
  annotate("text",x=xi-3.25,y=ytext3,parse=TRUE,
         label="y[i]-hat(y)[i]",size=3) 
dev.off() 
