# Abbildung 83 und 88 (Mafobuch, Faktorenanalyse prcomp)
library(MASS); library(ggrepel); setwd("C:/Users/Alpha/Desktop/R")
Data=read.csv("Beispiel1.csv",header=TRUE,sep=";",dec=",")

# PCA "von Hand"
# A=matrix(c(-1,-1,2,3,2,1,1,2,-2,-1,-2,-1),nrow=6); y=c(1,1,2,2,2,2)
# A[,1]=scale(A[,1]); A[,2]=scale(A[,2])  
for (j in 2:5){Data[,j]=scale(Data[,j])}
A=as.matrix(Data[,c(3,2,4,5)]); cor(A) # Alter, Einkommen, HHgre, Umsatz
n=dim(A)[1]; p=dim(A)[2] # i=1,...,n; j=1,...,p 
# aquer=colMeans(A); Aquer=A
# for (i in 1:n){for (j in 1:p){Aquer[i,j]=aquer[j]}}
# A; Aquer; A-Aquer
S=(t(A)%*%A)/(n-1); S
e=eigen(S); e$values; e$vectors
F=e$vectors
X=A %*% F

# PCA mit pcomp (wie im Skript)
fit=prcomp(A,scale=TRUE)
cov(A)
fit$sdev * fit$sdev
sum(fit$sdev * fit$sdev)
fit$sdev *fit$sdev/sum(fit$sdev * fit$sdev)
F=fit$rotation; F; FT=t(F); FT

# Faktorwerte  
X=A %*% F; X=as.data.frame(X)
AX=cbind(A,X)
cor(AX)

# Merkmalsraum
DataM=Data[,c(1,3,2,4,5)]; DataM$size=1
Merkmale=data.frame(matrix(as.numeric(FT), 
      attributes(FT)$dim, dimnames=attributes(FT)$dimnames))
Merkmale$Kunde[1]="Faktor 1"; Merkmale$Kunde[2]="Faktor 2";
Merkmale$Kunde[3]="Faktor 3"; Merkmale$Kunde[4]="Faktor 4";
Merkmale$size=0; DataM=rbind(DataM,Merkmale)
# Faktorraum
DataF=X; DataF$Kunde=Data$Kunde; DataF$size=1 
Merkmale=data.frame(matrix(as.numeric(F), 
      attributes(F)$dim, dimnames=attributes(F)$dimnames))
Merkmale$Kunde=attributes(F)$dimnames[[1]]; Merkmale$size=0
DataF=rbind(DataF,Merkmale)

# evtl. mit Varimax-Rotation
# F=F[,1:2]; F; F=varimax(F)$loadings; FT=t(F); FT
# X=A %*% F; X=as.data.frame(X)
# DataF=X; DataF$Kunde=Data$Kunde; DataF$size=1 
# Merkmale=data.frame(matrix(as.numeric(F), 
#                           attributes(F)$dim, dimnames=attributes(F)$dimnames))
# Merkmale$Kunde=attributes(F)$dimnames[[1]]; Merkmale$size=0
# DataF=rbind(DataF,Merkmale)

pdf(file="pdf/Abb83.pdf",width=11.7/2.54, height=11.7/2.54)
a=arrow(angle=30,length=unit(0.05,"inches"),ends="last",type="closed")
ggplot(DataM,aes(Alter,Einkommen,label=Kunde)) +
  geom_point(size=DataM$size) +
  geom_text_repel(parse=FALSE,size=3,box.padding=0.1,
                  point.padding=0.05,position="identity") +
  theme_classic(base_size=9) +
  xlab("Alter") + ylab("Einkommen") +
  theme(axis.title.x = element_text(size=9)) +
  theme(axis.text.x = element_text(size=9)) +
  theme(axis.line.x = element_line(size=0.25)) + 
  theme(axis.line.y = element_line(size=0.25)) + 
  theme(axis.ticks = element_line(size=0.25)) + 
  theme(axis.title.y = element_text(size=9)) + 
  theme(axis.text.y = element_text(size=9)) +
  expand_limits(x=-2.5, y=-2.5) + expand_limits(x=2.5, y=2.5) + 
  geom_segment(aes(x=0,y=0,xend=FT[1,1],yend=FT[1,2]),linetype="solid",size=0.25,arrow=a)+
  geom_segment(aes(x=0,y=0,xend=FT[2,1],yend=FT[2,2]),linetype="solid",size=0.25,arrow=a)+
  geom_segment(aes(x=0,y=0,xend=FT[3,1],yend=FT[3,2]),linetype="solid",size=0.25,arrow=a)+
  geom_segment(aes(x=0,y=0,xend=FT[4,1],yend=FT[4,2]),linetype="solid",size=0.25,arrow=a)+
  geom_vline(xintercept=0,linetype="solid",size=0.25) + geom_hline(yintercept=0,linetype="solid",size=0.25)  
dev.off() 

pdf(file="pdf/Abb83_not_shown.pdf",width=11.7/2.54, height=11.7/2.54)
a=arrow(angle=30,length=unit(0.05,"inches"),ends="last",type="closed")
ggplot(DataM,aes(Haushaltsgre,Umsatz,label=Kunde)) +
  geom_point(size=DataM$size) +
  geom_text_repel(parse=FALSE,size=3,box.padding=0.1,
                  point.padding=0.05,position="identity") +
  theme_classic(base_size=9) +
  xlab("Haushaltsgre") + ylab("Umsatz") +
  theme(axis.title.x = element_text(size=9)) +
  theme(axis.text.x = element_text(size=9)) +
  theme(axis.line.x = element_line(size=0.25)) + 
  theme(axis.line.y = element_line(size=0.25)) + 
  theme(axis.ticks = element_line(size=0.25)) + 
  theme(axis.title.y = element_text(size=9)) + 
  theme(axis.text.y = element_text(size=9)) +
  expand_limits(x=-2.5, y=-2.5) + expand_limits(x=2.5, y=2.5) + 
  geom_segment(aes(x=0,y=0,xend=FT[1,3],yend=FT[1,4]),linetype="solid",size=0.25,arrow=a)+
  geom_segment(aes(x=0,y=0,xend=FT[2,3],yend=FT[2,4]),linetype="solid",size=0.25,arrow=a)+
  geom_segment(aes(x=0,y=0,xend=FT[3,3],yend=FT[3,4]),linetype="solid",size=0.25,arrow=a)+
  geom_segment(aes(x=0,y=0,xend=FT[4,3],yend=FT[4,4]),linetype="solid",size=0.25,arrow=a)+
  geom_vline(xintercept=0,linetype="solid",size=0.25) + geom_hline(yintercept=0,linetype="solid",size=0.25)  
dev.off() 

pdf(file="pdf/Abb88.pdf",width=11.7/2.54, height=11.7/2.54)
a=arrow(angle=30,length=unit(0.05,"inches"),ends="last",type="closed")
ggplot(DataF,aes(PC1,PC2,label=Kunde)) +
  geom_point(size=DataF$size) +
  geom_text_repel(parse=FALSE,size=3,box.padding=0.1,
                  point.padding=0.05,position="identity") +
  theme_classic(base_size=9) +
  xlab("Faktor 1") + ylab("Faktor 2") +
  theme(axis.title.x = element_text(size=9)) +
  theme(axis.text.x = element_text(size=9)) +
  theme(axis.line.x = element_line(size=0.25)) + 
  theme(axis.line.y = element_line(size=0.25)) + 
  theme(axis.ticks = element_line(size=0.25)) + 
  theme(axis.title.y = element_text(size=9)) + 
  theme(axis.text.y = element_text(size=9)) +
  expand_limits(x=-4, y=-4) + expand_limits(x=4, y=4) + 
  geom_segment(aes(x=0,y=0,xend=F[1,1],yend=F[1,2]),linetype="solid",size=0.25,arrow=a)+
  geom_segment(aes(x=0,y=0,xend=F[2,1],yend=F[2,2]),linetype="solid",size=0.25,arrow=a)+
  geom_segment(aes(x=0,y=0,xend=F[3,1],yend=F[3,2]),linetype="solid",size=0.25,arrow=a)+
  geom_segment(aes(x=0,y=0,xend=F[4,1],yend=F[4,2]),linetype="solid",size=0.25,arrow=a)+
  geom_vline(xintercept=0,linetype="solid",size=0.25) + geom_hline(yintercept=0,linetype="solid",size=0.25)  
dev.off() 

pdf(file="pdf/Abb88_not_shown.pdf",width=11.7/2.54, height=11.7/2.54)
a=arrow(angle=30,length=unit(0.05,"inches"),ends="last",type="closed")
ggplot(DataF,aes(PC3,PC4,label=Kunde)) +
  geom_point(size=DataF$size) +
  geom_text_repel(parse=FALSE,size=3,box.padding=0.1,
                  point.padding=0.05,position="identity") +
  theme_classic(base_size=9) +
  xlab("Faktor 3") + ylab("Faktor 4") +
  theme(axis.title.x = element_text(size=9)) +
  theme(axis.text.x = element_text(size=9)) +
  theme(axis.line.x = element_line(size=0.25)) + 
  theme(axis.line.y = element_line(size=0.25)) + 
  theme(axis.ticks = element_line(size=0.25)) + 
  theme(axis.title.y = element_text(size=9)) + 
  theme(axis.text.y = element_text(size = 9)) +
  expand_limits(x=-4, y=-4) + expand_limits(x=4, y=4) + 
  geom_segment(aes(x=0,y=0,xend=F[1,3],yend=F[1,4]),linetype="solid",size=0.25,arrow=a)+
  geom_segment(aes(x=0,y=0,xend=F[2,3],yend=F[2,4]),linetype="solid",size=0.25,arrow=a)+
  geom_segment(aes(x=0,y=0,xend=F[3,3],yend=F[3,4]),linetype="solid",size=0.25,arrow=a)+
  geom_segment(aes(x=0,y=0,xend=F[4,3],yend=F[4,4]),linetype="solid",size=0.25,arrow=a)+
  geom_vline(xintercept=0,linetype="solid",size=0.25) + geom_hline(yintercept=0,linetype="solid",size=0.25)  
dev.off() 
