# Abbildung 90 und 91 (Mafobuch, hierarchischen Clusteranalyse hclust)
library(ggrepel); setwd("C:/Users/Alpha/Desktop/R")
Data=read.csv("Beispiel1.csv",header=TRUE,sep=";",dec=",")
Data=Data[,c(3,2)]; n=dim(Data)[1]
Data$Alter=scale(Data$Alter); Data$Einkommen=scale(Data$Einkommen)
Dist=dist(Data,method="euclid"); fit=hclust(Dist,method="average")
d12=sqrt((-1.053+1.453)**2+(-1.815+0.863)**2); d12
Dist; d12=abs(-1.053+1.453)+abs(-1.815+0.863); d12

ssq_h=1:n; ssq_k=1:n; ssq_h[n]=0; ssq_k[n]=0;
for (q in 1:(n-1)){
  cluster=cutree(fit,q); ssq_h[q]=0
  DataM=aggregate(Data, by=list(cluster=cluster),FUN=mean)
  for (i in 1:n){
    ssq_h[q]=ssq_h[q]+(Data$Alter[i]-DataM$Alter[cluster[i]])**2+
      (Data$Einkommen[i]-DataM$Einkommen[cluster[i]])**2
  }
  ssq_k[q]=kmeans(Data,q,iter.max=100)$tot.withinss
}
q=1:n; SSQh=data.frame(q=q,ssq=ssq_h); SSQh$Verfahren="Average linkage"
q=1:n; SSQk=data.frame(q=q,ssq=ssq_k); SSQk$Verfahren="k-Means"
SSQ=rbind(SSQk)

pdf(file="pdf/Abb90.pdf",width=11.7/2.54, height=7/2.54)
par(cex=0.7,font=1,mai=c(0,0.75,0.1,0))
plot(fit,main="",xlab="",ylab="Verschiedenheit",sub="",lwd=0.5)
# rect.hclust(fit,k=3,border=1)
dev.off() 

pdf(file="pdf/Abb91.pdf",width=11.7/2.54, height=6/2.54)
ggplot(data=SSQ,aes(x=q,y=ssq)) +
  geom_line(aes(linetype="solid"),size=0.25)+geom_point(size=0.5)+
  theme_classic(base_size=9) +
  labs(title="",x="Anzahl Klassen",y="Klasseninterne Summe der Quadrate") +
  scale_linetype_manual(values=c(1,2)) +
  theme(axis.title.x = element_text(size=9)) +
  theme(axis.text.x = element_text(size=9)) +
  theme(axis.title.y = element_text(size=9)) + 
  theme(axis.text.y = element_text(size=9)) +
  theme(axis.line.y=element_line(color='black',size=0.25))+
  theme(axis.line.x=element_line(color='black',size=0.25))+
  theme(axis.ticks=element_line(color='black',size=0.25))+ 
  theme(legend.position = "none") +
  expand_limits(x=0, y=0) + expand_limits(x=36,y=75) + 
  scale_x_continuous(expand = c(0, 0)) + 
  scale_y_continuous(expand = c(0, 0)) +
  theme(legend.position="none") 
dev.off() 
